curl --request POST \
--url https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"prompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12345"
}
'import requests
url = "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate"
payload = {
"prompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12345"
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"prompt\": \"Flow that contains form with name, surname and email of the user.\",\n \"responseId\": \"12345\"\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"prompt\": \"Flow that contains form with name, surname and email of the user.\",\n \"responseId\": \"12345\"\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'prompt' => 'Flow that contains form with name, surname and email of the user.',
'responseId' => '12345'
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
prompt: 'Flow that contains form with name, surname and email of the user.',
responseId: '12345'
})
};
fetch('https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"originalPrompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12346",
"generatedFlow": {
"version": "7.0",
"screens": [
{
"id": "USER_INFO_FORM",
"title": "User Information",
"terminal": true,
"success": true,
"layout": {
"type": "SingleColumnLayout",
"children": [
{
"type": "Form",
"name": "user_info_form",
"children": [
{
"type": "TextInput",
"label": "Name",
"name": "name",
"required": true
},
{
"type": "TextInput",
"label": "Surname",
"name": "surname",
"required": true
},
{
"type": "TextInput",
"label": "Email",
"name": "email",
"input-type": "email",
"required": true
},
{
"type": "Footer",
"label": "Submit",
"on-click-action": {
"name": "complete",
"payload": {
"name": "${form.name}",
"surname": "${form.surname}",
"email": "${form.email}"
}
}
}
]
}
]
}
}
]
}
}{
"errorCode": "E400",
"description": "Request cannot be processed.",
"action": "Check the syntax, violations and adjust the request.",
"violations": [],
"resources": []
}{
"errorCode": "E401",
"description": "The request lacks valid authentication credentials for the requested resource.",
"action": "Check the resources and adjust authentication credentials.",
"violations": [],
"resources": [
{
"name": "API Authentication",
"url": "https://www.phonovation.com/docs/essentials/api-authentication"
}
]
}{
"errorCode": "E403",
"description": "Insufficient permissions to access the requested resource.",
"action": "Repeat the request with new or different credentials.",
"violations": [],
"resources": [
{
"name": "API Scopes",
"url": "https://www.phonovation.com/docs/essentials/api-essentials/api-authorization#api-scopes"
}
]
}{
"errorCode": "WA-FLOW-SENDER404",
"description": "Sender not found.",
"action": "Please check the sender and try again.",
"violations": [],
"resources": []
}{
"errorCode": "E429",
"description": "Too many requests sent.",
"action": "Check request rate limit specified in the API endpoint documentation resource.",
"violations": [],
"resources": [
{
"name": "Throttling handling errors",
"url": "https://www.phonovation.com/docs/essentials/integration-best-practices#throttling-handling-errors"
}
]
}{
"errorCode": "E500",
"description": "Something went wrong.",
"action": "Contact the support.",
"violations": [],
"resources": []
}Generate WhatsApp Flow
Use this endpoint to automatically generate a WhatsApp Flow definition using AI, based on a natural language prompt. Provide a descriptive prompt (e.g., “Create a Static WhatsApp Flow to collect details like Name, Surname and email for our global event next week.”). The AI will generate a flow configuration designed to match your intent. If you include a responseId from an earlier request, the prompt will be used to modify or refine the flow that was previously generated, so you can adjust and improve it step by step.
Required scope: Enable one of: whatsapp:manage.
curl --request POST \
--url https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"prompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12345"
}
'import requests
url = "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate"
payload = {
"prompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12345"
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"prompt\": \"Flow that contains form with name, surname and email of the user.\",\n \"responseId\": \"12345\"\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"prompt\": \"Flow that contains form with name, surname and email of the user.\",\n \"responseId\": \"12345\"\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'prompt' => 'Flow that contains form with name, surname and email of the user.',
'responseId' => '12345'
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
prompt: 'Flow that contains form with name, surname and email of the user.',
responseId: '12345'
})
};
fetch('https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/flows/generate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"originalPrompt": "Flow that contains form with name, surname and email of the user.",
"responseId": "12346",
"generatedFlow": {
"version": "7.0",
"screens": [
{
"id": "USER_INFO_FORM",
"title": "User Information",
"terminal": true,
"success": true,
"layout": {
"type": "SingleColumnLayout",
"children": [
{
"type": "Form",
"name": "user_info_form",
"children": [
{
"type": "TextInput",
"label": "Name",
"name": "name",
"required": true
},
{
"type": "TextInput",
"label": "Surname",
"name": "surname",
"required": true
},
{
"type": "TextInput",
"label": "Email",
"name": "email",
"input-type": "email",
"required": true
},
{
"type": "Footer",
"label": "Submit",
"on-click-action": {
"name": "complete",
"payload": {
"name": "${form.name}",
"surname": "${form.surname}",
"email": "${form.email}"
}
}
}
]
}
]
}
}
]
}
}{
"errorCode": "E400",
"description": "Request cannot be processed.",
"action": "Check the syntax, violations and adjust the request.",
"violations": [],
"resources": []
}{
"errorCode": "E401",
"description": "The request lacks valid authentication credentials for the requested resource.",
"action": "Check the resources and adjust authentication credentials.",
"violations": [],
"resources": [
{
"name": "API Authentication",
"url": "https://www.phonovation.com/docs/essentials/api-authentication"
}
]
}{
"errorCode": "E403",
"description": "Insufficient permissions to access the requested resource.",
"action": "Repeat the request with new or different credentials.",
"violations": [],
"resources": [
{
"name": "API Scopes",
"url": "https://www.phonovation.com/docs/essentials/api-essentials/api-authorization#api-scopes"
}
]
}{
"errorCode": "WA-FLOW-SENDER404",
"description": "Sender not found.",
"action": "Please check the sender and try again.",
"violations": [],
"resources": []
}{
"errorCode": "E429",
"description": "Too many requests sent.",
"action": "Check request rate limit specified in the API endpoint documentation resource.",
"violations": [],
"resources": [
{
"name": "Throttling handling errors",
"url": "https://www.phonovation.com/docs/essentials/integration-best-practices#throttling-handling-errors"
}
]
}{
"errorCode": "E500",
"description": "Something went wrong.",
"action": "Contact the support.",
"violations": [],
"resources": []
}Authorizations
This is the most secure authorization type and the one with the most flexibility.
API keys can be generated by calling the dedicated API method. Furthermore, API keys can have a limited scope and cover only some API methods. Lastly, they can be revoked at any time. This range of possibilities makes API keys well suited for separating the API access rights across multiple applications or use cases. Finally, the loss of an API key is easily manageable.
You can manage your API keys from GUI, or programmatically with dedicated API.
API key Authorization header example:
Authorization: App 003026bbc133714df1834b8638bb496e-8f4b3d9a-e931-478d-a994-28a725159ab9
Path Parameters
Registered WhatsApp sender number. Must be in international format.
1Body
Prompt for flow generation.
1"Flow that contains form with name, surname and email of the user."
Optional identifier of a previous response. If provided, this request will update or modify the generatedFlow associated with the given responseId. Use this to refine or change an existing flow by referencing an earlier response.
"12345"
Response
Generated whatsapp flow
The prompt text used to generate this flow.
"Flow that contains form with name, surname and email of the user."
Unique identifier for this response. Use this value in future requests to reference generated flow.
"12345"
The generated output corresponding to the provided prompt.